NetBSD Problem Report #50310

From www@NetBSD.org  Wed Oct  7 12:17:34 2015
Return-Path: <www@NetBSD.org>
Received: from mail.netbsd.org (mail.netbsd.org [149.20.53.66])
	(using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
	(Client CN "mail.netbsd.org", Issuer "Postmaster NetBSD.org" (verified OK))
	by mollari.NetBSD.org (Postfix) with ESMTPS id D42D9A5B2E
	for <gnats-bugs@gnats.NetBSD.org>; Wed,  7 Oct 2015 12:17:33 +0000 (UTC)
Message-Id: <20151007121732.9B80EA6555@mollari.NetBSD.org>
Date: Wed,  7 Oct 2015 12:17:32 +0000 (UTC)
From: frederic@fauberteau.org
Reply-To: frederic@fauberteau.org
To: gnats-bugs@NetBSD.org
Subject: print/cups build fails with builtin heimdal
X-Send-Pr-Version: www-1.0

>Number:         50310
>Category:       pkg
>Synopsis:       print/cups build fails with builtin heimdal
>Confidential:   no
>Severity:       critical
>Priority:       medium
>Responsible:    pkg-manager
>State:          open
>Class:          sw-bug
>Submitter-Id:   net
>Arrival-Date:   Wed Oct 07 12:20:00 +0000 2015
>Last-Modified:  Tue Aug 02 14:50:00 +0000 2016
>Originator:     Frédéric Fauberteau
>Release:        pkgsrc-2015Q3
>Organization:
>Environment:
NetBSD trashware 6.1_STABLE NetBSD 6.1_STABLE (TRASHWARE) #0: Tue Jul  7 09:13:34 CEST 2015  triaxx@trashware:/home/triaxx/dev/nbsd/netbsd-6/obj/sys/arch/amd64/compile/TRASHWARE amd64
>Description:
cups build fails on a link error due to missing krb5 libraries.

print/cups is parameterized as follows:
These options are enabled by default:
        dbus dnssd kerberos libusb

These options are currently enabled:
        dnssd kerberos libusb

the compilation error message is:
ld: cannot find -lgssapi_krb5
ld: cannot find -lk5crypto

the content of /usr/pkgsrc/print/cups/work/.buildlink/lib does not contain any link to 'gssapi_krb5' of 'k5crypto' library. The build process detects USE_BUILTIN.heimdal=yes but neither /usr/lib/libgssapi_krb5*.so nor /usr/lib/libk5crypto*.so exist.
>How-To-Repeat:
Build print/cups with kerberos support and builtin heimdal
>Fix:

>Release-Note:

>Audit-Trail:
From: =?UTF-8?Q?Fr=C3=A9d=C3=A9ric_Fauberteau?= <frederic@fauberteau.org>
To: gnats-bugs@netbsd.org
Cc: 
Subject: Re: pkg/50310: print/cups build fails with builtin heimdal
Date: Fri, 09 Oct 2015 10:58:04 +0200

 Le 07/10/2015 14:20, frederic@fauberteau.org a écrit :
 >> Number:         50310
 >> Category:       pkg
 >> Synopsis:       print/cups build fails with builtin heimdal
 >> Confidential:   no
 >> Severity:       critical
 >> Priority:       medium
 >> Responsible:    pkg-manager
 >> State:          open
 >> Class:          sw-bug
 >> Submitter-Id:   net
 >> Arrival-Date:   Wed Oct 07 12:20:00 +0000 2015
 >> Originator:     Fr�d�ric Fauberteau
 >> Release:        pkgsrc-2015Q3
 >> Organization:
 >> Environment:
 > NetBSD trashware 6.1_STABLE NetBSD 6.1_STABLE (TRASHWARE) #0: Tue Jul
 > 7 09:13:34 CEST 2015
 > triaxx@trashware:/home/triaxx/dev/nbsd/netbsd-6/obj/sys/arch/amd64/compile/TRASHWARE
 > amd64
 >> Description:
 > cups build fails on a link error due to missing krb5 libraries.
 > 
 > print/cups is parameterized as follows:
 > These options are enabled by default:
 >         dbus dnssd kerberos libusb
 > 
 > These options are currently enabled:
 >         dnssd kerberos libusb
 > 
 > the compilation error message is:
 > ld: cannot find -lgssapi_krb5
 > ld: cannot find -lk5crypto
 > 
 > the content of /usr/pkgsrc/print/cups/work/.buildlink/lib does not
 > contain any link to 'gssapi_krb5' of 'k5crypto' library. The build
 > process detects USE_BUILTIN.heimdal=yes but neither
 > /usr/lib/libgssapi_krb5*.so nor /usr/lib/libk5crypto*.so exist.
 >> How-To-Repeat:
 > Build print/cups with kerberos support and builtin heimdal
 >> Fix:

 More details:
 Actually, mit-krb5 was installed. Then configure script of cups find 
 /usr/pkg/bin/krb5-config. But since pkgsrc detect heimdal from 
 basesystem and KRB5_DEFAULT is set to heimdal, nothing is buildlinked 
 into work/.buildlink.

From: =?UTF-8?Q?Fr=C3=A9d=C3=A9ric_Fauberteau?= <frederic@fauberteau.org>
To: gnats-bugs@netbsd.org
Cc: 
Subject: Re: pkg/50310: print/cups build fails with builtin heimdal
Date: Sat, 10 Oct 2015 10:12:39 +0200

 Le 09/10/2015 10:55, Frédéric Fauberteau a écrit :
 > The following reply was made to PR pkg/50310; it has been noted by 
 > GNATS.
 > 
 > From: =?UTF-8?Q?Fr=C3=A9d=C3=A9ric_Fauberteau?= 
 > <frederic@fauberteau.org>
 > To: gnats-bugs@netbsd.org
 > Cc:
 > Subject: Re: pkg/50310: print/cups build fails with builtin heimdal
 > Date: Fri, 09 Oct 2015 10:58:04 +0200
 > 
 >  Le 07/10/2015 14:20, frederic@fauberteau.org a écrit :
 >  >> Number:         50310
 >  >> Category:       pkg
 >  >> Synopsis:       print/cups build fails with builtin heimdal
 >  >> Confidential:   no
 >  >> Severity:       critical
 >  >> Priority:       medium
 >  >> Responsible:    pkg-manager
 >  >> State:          open
 >  >> Class:          sw-bug
 >  >> Submitter-Id:   net
 >  >> Arrival-Date:   Wed Oct 07 12:20:00 +0000 2015
 >  >> Originator:     Fr�d�ric Fauberteau
 >  >> Release:        pkgsrc-2015Q3
 >  >> Organization:
 >  >> Environment:
 >  > NetBSD trashware 6.1_STABLE NetBSD 6.1_STABLE (TRASHWARE) #0: Tue 
 > Jul
 >  > 7 09:13:34 CEST 2015
 >  >
 > triaxx@trashware:/home/triaxx/dev/nbsd/netbsd-6/obj/sys/arch/amd64/compile/TRASHWARE
 >  > amd64
 >  >> Description:
 >  > cups build fails on a link error due to missing krb5 libraries.
 > 
 >  More details:
 >  Actually, mit-krb5 was installed. Then configure script of cups find
 >  /usr/pkg/bin/krb5-config. But since pkgsrc detect heimdal from
 >  basesystem and KRB5_DEFAULT is set to heimdal, nothing is buildlinked
 >  into work/.buildlink.

 The cups configure script detects the krb5-config script of mit-krb5 
 whereas the basesystem heimdal implementation is present and 
 KRB5_DEFAULT is set to heimdal. pkgsrc detects the system heimdal 
 version since log shows that USE_BUILTIN.heimdal is set to yes. pkgsrc 
 exports the variable KRB5_CONFIG=/usr/bin/krb5-config.

 I am not really sure how to solve the problem but the following patch 
 correct it:
 Index: options.mk
 ===================================================================
 RCS file: /cvsroot/pkgsrc/print/cups/options.mk,v
 retrieving revision 1.18
 diff -u -r1.18 options.mk
 --- options.mk  23 Aug 2014 20:02:11 -0000  1.18
 +++ options.mk  10 Oct 2015 07:09:28 -0000
 @@ -42,6 +42,9 @@
   .if !empty(PKG_OPTIONS:Mkerberos)
   .include "../../mk/krb5.buildlink3.mk"
   CONFIGURE_ARGS+= --enable-gssapi
 +.if !empty(USE_BUILTIN.heimdal:Myes)
 +CONFIGURE_ENV+=  KRB5CONFIG=/usr/bin/krb5-config
 +.endif
   .else
   CONFIGURE_ARGS+= --disable-gssapi
   .endif

 Maybe the following one is more adapted:
 $NetBSD$

 --- config-scripts/cups-gssapi.m4.orig  2014-06-10 13:54:53.000000000 
 +0000
 +++ config-scripts/cups-gssapi.m4
 @@ -22,8 +22,8 @@ LIBGSSAPI=""
   AC_SUBST(LIBGSSAPI)

   if test x$enable_gssapi != xno; then
 - AC_PATH_TOOL(KRB5CONFIG, krb5-config)
 - if test "x$KRB5CONFIG" != x; then
 + AC_PATH_TOOL(KRB5_CONFIG, krb5-config)
 + if test "x$KRB5_CONFIG" != x; then
      case "$uname" in
        Darwin)
          # OS X weak-links to the Kerberos framework...
 @@ -40,15 +40,15 @@ if test x$enable_gssapi != xno; then
          # Solaris has a non-standard krb5-config, don't use it!
          AC_CHECK_LIB(gss, gss_display_status,
            AC_DEFINE(HAVE_GSSAPI, 1, [Whether GSSAPI is available])
 -         CFLAGS="`$KRB5CONFIG --cflags` $CFLAGS"
 -         CPPFLAGS="`$KRB5CONFIG --cflags` $CPPFLAGS"
 -         LIBGSSAPI="-lgss `$KRB5CONFIG --libs`")
 +         CFLAGS="`$KRB5_CONFIG --cflags` $CFLAGS"
 +         CPPFLAGS="`$KRB5_CONFIG --cflags` $CPPFLAGS"
 +         LIBGSSAPI="-lgss `$KRB5_CONFIG --libs`")
          ;;
        *)
          # Other platforms just ask for GSSAPI
 -       CFLAGS="`$KRB5CONFIG --cflags gssapi` $CFLAGS"
 -       CPPFLAGS="`$KRB5CONFIG --cflags gssapi` $CPPFLAGS"
 -       LIBGSSAPI="`$KRB5CONFIG --libs gssapi`"
 +       CFLAGS="`$KRB5_CONFIG --cflags gssapi` $CFLAGS"
 +       CPPFLAGS="`$KRB5_CONFIG --cflags gssapi` $CPPFLAGS"
 +       LIBGSSAPI="`$KRB5_CONFIG --libs gssapi`"
          ;;
      esac
      AC_DEFINE(HAVE_GSSAPI, 1, [Whether GSSAPI is available])

From: =?UTF-8?Q?Fr=C3=A9d=C3=A9ric_Fauberteau?= <frederic@fauberteau.org>
To: gnats-bugs@netbsd.org
Cc: sbd@NetBSD.org
Subject: Re: pkg/50310: print/cups build fails with builtin heimdal
Date: Mon, 02 Nov 2015 10:18:05 +0100

 Le 07/10/2015 14:20, frederic@fauberteau.org a écrit :
 >> Number:         50310
 >> Category:       pkg
 >> Synopsis:       print/cups build fails with builtin heimdal
 >> Confidential:   no
 >> Severity:       critical
 >> Priority:       medium
 >> Responsible:    pkg-manager
 >> State:          open
 >> Class:          sw-bug
 >> Submitter-Id:   net
 >> Arrival-Date:   Wed Oct 07 12:20:00 +0000 2015
 >> Originator:     Fr�d�ric Fauberteau
 >> Release:        pkgsrc-2015Q3
 >> Organization:
 >> Environment:
 > NetBSD trashware 6.1_STABLE NetBSD 6.1_STABLE (TRASHWARE) #0: Tue Jul
 > 7 09:13:34 CEST 2015
 > triaxx@trashware:/home/triaxx/dev/nbsd/netbsd-6/obj/sys/arch/amd64/compile/TRASHWARE
 > amd64
 >> Description:
 > cups build fails on a link error due to missing krb5 libraries.
 > 
 > print/cups is parameterized as follows:
 > These options are enabled by default:
 >         dbus dnssd kerberos libusb
 > 
 > These options are currently enabled:
 >         dnssd kerberos libusb
 > 
 > the compilation error message is:
 > ld: cannot find -lgssapi_krb5
 > ld: cannot find -lk5crypto
 > 
 > the content of /usr/pkgsrc/print/cups/work/.buildlink/lib does not
 > contain any link to 'gssapi_krb5' of 'k5crypto' library. The build
 > process detects USE_BUILTIN.heimdal=yes but neither
 > /usr/lib/libgssapi_krb5*.so nor /usr/lib/libk5crypto*.so exist.
 >> How-To-Repeat:
 > Build print/cups with kerberos support and builtin heimdal
 >> Fix:

 Applying this patch:
 ==========
   $NetBSD$

   --- config-scripts/cups-gssapi.m4.orig  2014-06-10 13:54:53.000000000
   +0000
   +++ config-scripts/cups-gssapi.m4
   @@ -22,8 +22,8 @@ LIBGSSAPI=""
     AC_SUBST(LIBGSSAPI)

     if test x$enable_gssapi != xno; then
   - AC_PATH_TOOL(KRB5CONFIG, krb5-config)
   - if test "x$KRB5CONFIG" != x; then
   + AC_PATH_TOOL(KRB5_CONFIG, krb5-config)
   + if test "x$KRB5_CONFIG" != x; then
        case "$uname" in
          Darwin)
            # OS X weak-links to the Kerberos framework...
   @@ -40,15 +40,15 @@ if test x$enable_gssapi != xno; then
            # Solaris has a non-standard krb5-config, don't use it!
            AC_CHECK_LIB(gss, gss_display_status,
              AC_DEFINE(HAVE_GSSAPI, 1, [Whether GSSAPI is available])
   -         CFLAGS="`$KRB5CONFIG --cflags` $CFLAGS"
   -         CPPFLAGS="`$KRB5CONFIG --cflags` $CPPFLAGS"
   -         LIBGSSAPI="-lgss `$KRB5CONFIG --libs`")
   +         CFLAGS="`$KRB5_CONFIG --cflags` $CFLAGS"
   +         CPPFLAGS="`$KRB5_CONFIG --cflags` $CPPFLAGS"
   +         LIBGSSAPI="-lgss `$KRB5_CONFIG --libs`")
            ;;
          *)
            # Other platforms just ask for GSSAPI
   -       CFLAGS="`$KRB5CONFIG --cflags gssapi` $CFLAGS"
   -       CPPFLAGS="`$KRB5CONFIG --cflags gssapi` $CPPFLAGS"
   -       LIBGSSAPI="`$KRB5CONFIG --libs gssapi`"
   +       CFLAGS="`$KRB5_CONFIG --cflags gssapi` $CFLAGS"
   +       CPPFLAGS="`$KRB5_CONFIG --cflags gssapi` $CPPFLAGS"
   +       LIBGSSAPI="`$KRB5_CONFIG --libs gssapi`"
            ;;
        esac
        AC_DEFINE(HAVE_GSSAPI, 1, [Whether GSSAPI is available])
 ==========

Responsible-Changed-From-To: pkg-manager->sbd
Responsible-Changed-By: bsiegert@NetBSD.org
Responsible-Changed-When: Mon, 28 Dec 2015 13:35:26 +0000
Responsible-Changed-Why:
Over to maintainer.


Responsible-Changed-From-To: sbd->pkg-manager
Responsible-Changed-By: dholland@NetBSD.org
Responsible-Changed-When: Sun, 26 Jun 2016 04:33:32 +0000
Responsible-Changed-Why:
sbd resigned and shouldn't own PRs


From: Patrick Welche <prlw1@cam.ac.uk>
To: gnats-bugs@NetBSD.org
Cc: 
Subject: Re: pkg/50310 (print/cups build fails with builtin heimdal)
Date: Tue, 2 Aug 2016 15:49:26 +0100

 Just hit exactly the same problem on NetBSD-7.99.35/amd64 and -current
 pkgsrc. "pkg_delete mit-krb5" got me a successful build. I suppose the
 question is: if you have base kerberos and mit-krb5 kerberos, which
 one should cups use?

>Unformatted:

NetBSD Home
NetBSD PR Database Search

(Contact us) $NetBSD: query-full-pr,v 1.39 2013/11/01 18:47:49 spz Exp $
$NetBSD: gnats_config.sh,v 1.8 2006/05/07 09:23:38 tsutsui Exp $
Copyright © 1994-2014 The NetBSD Foundation, Inc. ALL RIGHTS RESERVED.